OpenTTD Source: src/ship.h File Reference

OpenTTD Source 14.0-RC3

Data Structures | Typedefs | Functions
ship.h File Reference
`#include "vehicle_base.h"`
`#include "water_map.h"`

Go to the source code of this file.

## Data Structures
struct | Ship
| All ships have this type. More...

## Typedefs
typedef std::deque< Trackdir > | ShipPathCache

## Functions
void | GetShipSpriteSize (EngineID engine, uint &width, uint &height, int &xoffs, int &yoffs, EngineImageType image_type)
| Get the size of the sprite of a ship sprite heading west (used for lists). More...
WaterClass | GetEffectiveWaterClass (TileIndex tile)
| Determine the effective WaterClass for a ship travelling on a tile. More...
bool | IsShipDestinationTile (TileIndex tile, StationID station)
| Test if a tile is a docking tile for the given station. More...

## Detailed Description

Base for ships.

Definition in file ship.h.

## Function Documentation

## ◆ GetEffectiveWaterClass()

WaterClass GetEffectiveWaterClass | ( | TileIndex | tile | ) |

Determine the effective WaterClass for a ship travelling on a tile.

Parameters

  tile | Tile of interest

Returns
  the waterclass to be used by the ship.

Definition at line 55 of file ship_cmd.cpp.

References GetTunnelBridgeTransportType(), GetWaterClass(), HasTileWaterClass(), IsTileType(), MP_RAILWAY, MP_TUNNELBRIDGE, TRANSPORT_WATER, and WATER_CLASS_CANAL.

## ◆ GetShipSpriteSize()

void GetShipSpriteSize | ( | EngineID | engine,
|  | uint & | width,
|  | uint & | height,
|  | int & | xoffs,
|  | int & | yoffs,
|  | EngineImageType | image_type
| ) |  |

Get the size of the sprite of a ship sprite heading west (used for lists).

Parameters

  | engine | The engine to get the sprite from.
  [out] | width | The width of the sprite.
  [out] | height | The height of the sprite.
  [out] | xoffs | Number of pixels to shift the sprite to the right.
  [out] | yoffs | Number of pixels to shift the sprite downwards.
  | image_type | Context the sprite is used in.

Definition at line 121 of file ship_cmd.cpp.

## ◆ IsShipDestinationTile()

bool IsShipDestinationTile | ( | TileIndex | tile,
|  | StationID | station
| ) |  |

Test if a tile is a docking tile for the given station.

Parameters

  tile | Docking tile to test.
  station | Destination station.

Returns
  true iff docking tile is next to station.

Definition at line 666 of file ship_cmd.cpp.

References DIAGDIR_BEGIN, DIAGDIR_END, Industry::GetByTile(), GetStationIndex(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, IsDockingTile(), IsDockTile(), IsDockWaterPart(), IsOilRig(), IsTileType(), IsValidTile(), MP_INDUSTRY, MP_STATION, Industry::neutral_station, and TileOffsByDiagDir().